/*
 * WiPal - A library and a set of tools to manipulate wireless traces.
 * Copyright (C) 2007  Universite Pierre et Marie Curie - Paris 6
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA
 *
 * Author: Thomas Claveirole <thomas.claveirole@lip6.fr>
 */
#ifndef WIFI_FRAME_FILTER_REFERENCE_BLACKLIST_HXX_
# define WIFI_FRAME_FILTER_REFERENCE_BLACKLIST_HXX_

# include "reference_blacklist.hxx"

namespace wifi
{
  namespace frame
  {
    namespace filter
    {

      namespace internals
      {

	inline
	blacklist_predicate::blacklist_predicate(const blacklist& l):
	  blacklist_ (l)
	{
	}

	template <class T>
	bool
	blacklist_predicate::operator () (const T& item) const
	{
	  const blacklist_item	i (item.first.frame_id(),
				   item.second.frame_id());

	  return blacklist_.find(i) == blacklist_.end();
	}

      } // End of namespace wifi::frame::filter::internals.

      template <class I, class B>
      reference_blacklist<I, B>::reference_blacklist(const I&		first,
						     const I&		last,
						     const blacklist&	l):
	super_type (first, last, l)
      {
      }

    } // End of namespace wifi::frame::filter.

  } // End of namespace wifi::frame.

} // End of namespace wifi.

#endif // ! WIFI_FRAME_FILTER_SIMPLE_MERGE_HXX_
